SystemOrganization addCategory: #'PhysicalEtoys-Utilities'!

CircleMorph subclass: #PEAttachmentPointMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhysicalEtoys-Utilities'!

!PEAttachmentPointMorph commentStamp: 'Richo 9/15/2009 12:32' prior: 0!
I exist only for esthetical purposes. I make sure that wires connecting devices are attached to the correct points (not the center) of the morphs.!

!PEAttachmentPointMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/1/2009 16:07'!
disconnectedFromBy: aConnector

owner disconnectedFromBy: aConnector.! !

Object subclass: #PESerialPortList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhysicalEtoys-Utilities'!

!PESerialPortList class methodsFor: 'general' stamp: 'Richo 11/10/2009 16:33'!
availableBluetoothPorts
^self platformName caseOf: {
				['unix'] -> [self availableBluetoothPortsForUnix].
				['Win32'] -> [self availableBluetoothPortsForWindows]}
				 otherwise: [self error: 'Not supported platform']! !

!PESerialPortList class methodsFor: 'unix' stamp: 'Richo 11/10/2009 16:19'!
availableBluetoothPortsForUnix
	| pattern1 |
	self error: 'Arreglar el pattern'.
	pattern1 := 'ttyUSB*'.
	 ^(FileDirectory on: '/dev') fileNames
		select: [:e | (pattern1 match: e)]
		thenCollect: [:e |( '/dev/' , e)  asSymbol]! !

!PESerialPortList class methodsFor: 'win32' stamp: 'Richo 11/10/2009 17:31'!
availableBluetoothPortsForWindows
^self availableSerialPortsForWindows! !

!PESerialPortList class methodsFor: 'general' stamp: 'Richo 11/10/2009 16:33'!
availableSerialPorts
^self platformName caseOf: {
				['unix'] -> [self availableSerialPortsForUnix].
				['Win32'] -> [self availableSerialPortsForWindows]}
				 otherwise: [self error: 'Not supported platform']! !

!PESerialPortList class methodsFor: 'unix' stamp: 'Richo 11/10/2009 16:14'!
availableSerialPortsForUnix

	| pattern1 |
	pattern1 := 'ttyS*'.
	 ^(FileDirectory on: '/dev') fileNames
		select: [:e | (pattern1 match: e)]
		thenCollect: [:e |( '/dev/' , e)  asSymbol]! !

!PESerialPortList class methodsFor: 'win32' stamp: 'Richo 11/10/2009 17:20'!
availableSerialPortsForWindows
"It should return only the list of available serial ports. Since I don't know how to do it in windows, I just return a list from COM1 to COM9"
 ^ (1 to: 9)
					collect: [:n | ('COM' , n asString) asSymbol]! !

!PESerialPortList class methodsFor: 'general' stamp: 'Richo 11/10/2009 16:33'!
availableUSBPorts
^self platformName caseOf: {
				['unix'] -> [self availableUSBPortsForUnix].
				['Win32'] -> [self availableUSBPortsForWindows]}
				 otherwise: [self error: 'Not supported platform']! !

!PESerialPortList class methodsFor: 'unix' stamp: 'Richo 11/10/2009 16:15'!
availableUSBPortsForUnix

	| pattern1 |
	pattern1 := 'ttyUSB*'.
	 ^(FileDirectory on: '/dev') fileNames
		select: [:e | (pattern1 match: e)]
		thenCollect: [:e |( '/dev/' , e)  asSymbol]! !

!PESerialPortList class methodsFor: 'win32' stamp: 'Richo 11/10/2009 16:19'!
availableUSBPortsForWindows
^self availableSerialPortsForWindows ! !

!PESerialPortList class methodsFor: 'accessing' stamp: 'Richo 11/10/2009 16:13'!
platformName
^ SmalltalkImage current platformName! !

NCAAConnectorMorph subclass: #PEWireMorph
	instanceVariableNames: 'isControllingConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhysicalEtoys-Utilities'!

!PEWireMorph commentStamp: 'Richo 9/15/2009 12:22' prior: 0!
Abstract class. I represent the wire which connects different etoys. The difference with my superclass is that I control that the connections are valid by checking the classes of my sourceMorph and destinationMorph. Subclasses have to override #validConnectionClasses (see class side).!

!PEWireMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/25/2009 10:19'!
defaultNameStemForInstances
^'Wire'! !

!PEWireMorph class methodsFor: 'instance creation' stamp: 'Richo 11/10/2009 12:17'!
fromMorph: aMorph toMorph: anotherMorph
"Recuerda los morphs originales para borrarse si estos cambian"
	^( (super
		fromMorph: aMorph
		toMorph: anotherMorph
		) ) startControllingConnections! !

!PEWireMorph class methodsFor: 'constants' stamp: 'Richo 11/10/2009 12:25'!
validConnectionClasses
"Returns an array of valid classes to connect. Subclasses may override this method"
^{PEAttachmentPointMorph}! !

!PEWireMorph methodsFor: 'menu' stamp: 'Richo 10/7/2008 18:20'!
addCustomMenuItems: aMenu hand: aHand 
"Esto evita que se aadan las opciones de connectors al men"
	^ aMenu! !

!PEWireMorph methodsFor: 'connection control' stamp: 'Richo 9/8/2009 13:46'!
controlConnections
"No borrar, es muy importante!! Se fija si las conexiones son vlidas y si no es as se elimina"

(self hasValidClass: self sourceMorph) ifFalse: [self isInWorld ifTrue: [self delete]].
(self hasValidClass: self destinationMorph) ifFalse: [self isInWorld ifTrue: [self delete]].

Cursor normal show.! !

!PEWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:25'!
handlesMouseOver: evt 
	^ false! !

!PEWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:25'!
handlesMouseOverDragging: evt 
	^ false! !

!PEWireMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/8/2009 13:47'!
hasValidClass: aMorph 
	self class validConnectionClasses
		do: [:each | (aMorph isKindOf: each)
				ifTrue: [^ true]].
	^ false! !

!PEWireMorph methodsFor: 'initialization' stamp: 'Richo 9/1/2009 16:14'!
initialize
"isControllingConnections se debe inicializar primero porque sino luego tira error porque en algn lado se ejecuta #connectionsChanged. Una alternativa sera usar lazy initialization, lo que sea ms claro"
isControllingConnections := false.
super initialize.! !

!PEWireMorph methodsFor: 'testing' stamp: 'Richo 2/11/2009 13:44'!
isPlugged
	^ self sourceMorph notNil
		and: [self destinationMorph notNil]! !

!PEWireMorph methodsFor: 'connection control' stamp: 'Richo 9/1/2009 11:53'!
startControllingConnections
isControllingConnections := true.! !

!PEWireMorph methodsFor: 'stepping' stamp: 'Richo 11/10/2009 12:08'!
step
super step.

isControllingConnections ifTrue: [self controlConnections].! !

!PEWireMorph methodsFor: 'stepping' stamp: 'Richo 11/10/2009 12:08'!
stepTime
^50! !

!PEWireMorph methodsFor: 'connection control' stamp: 'Richo 9/1/2009 11:53'!
stopControllingConnections
isControllingConnections := false.! !

!PEWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:07'!
understandsBorderVocabulary
^false! !

!PEWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 18:21'!
wantsConnectionVocabulary
	^ false! !

!PEWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 15:04'!
wantsConnectorVocabulary
	^ false! !

!PEWireMorph methodsFor: 'no se si sirve' stamp: 'Richo 10/7/2008 18:21'!
wantsEmbeddingsVocabulary
	^ false! !

!PEWireMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/8/2009 13:46'!
wantsToAttachEnd: index toMorph: aMorph
^self hasValidClass: aMorph ! !
